// ----------------------------------------------------------------------------
// vita - 2channel virtual BillBoardSystem Virtual Ita
// programmed by 193	(v0.1.0)
// reprogrammed by 246	(v0.2.0)
// reprogrammed by 193	(v0.3.0)
// ڍׂREADME_JQ
// ----------------------------------------------------------------------------

#include "vita_option.h"
#include "vita_funcs.h"
#include "vita_classes.h"

#define  DEBUG_OUTPUT

// ----------------------------------------------------------------------------
// Global
// ----------------------------------------------------------------------------
int  g_nInhabitant		= 100;
int  g_nCraftsman		= 10;
int  g_nMaxThread		= 1000;
int  g_nMaxKakiko		= 1000;
int  g_nResponseTime		= 60;
int  g_nThreadCreateTime	= 60;

CSubjectManager  g_SubjectManager;

// ----------------------------------------------------------------------------
// Usage/Version
// ----------------------------------------------------------------------------
void OutUsage() {
	printf ("\n");
	printf ("Usage : vita [option...]\n");
	printf ("\n");
	printf ("Options :\n");
	printf ("   -c c_num   Thread create craftsman num (default=10).\n");
	printf ("   -h         Show help.\n");
	printf ("   -i p_num   Inhabitant people num (default=100).\n");
	printf ("   -m t_num   Max thread num (default=1000).\n");
	printf ("   -r r_sec   Response average time [sec](default=60).\n");
	printf ("   -t c_num   Thread create average time [sec](default=60).\n");
	printf ("   -v         Show version.\n");
	printf ("\n");
}

void OutVersion() {
	printf ("\n");
	printf ("2channel virtual BillBoardSystem \"Virtual Ita\".\n");
	printf ("\n");
	printf ("Version 0.3.0\n");
	printf ("Last update 29.Sep.2005\n");
	printf ("Copyright 2005 VIPPER\n");
	printf ("\n");
}

// ----------------------------------------------------------------------------
// main
// ----------------------------------------------------------------------------
int main(int argc,char* argv[]) {
	/*
	g_nCraftsman = 30;
	g_nInhabitant = 1000;
	g_nMaxThread = 100000;
	g_nResponseTime = 3;
	g_nThreadCreateTime = 5;
	*/

	try {
		for (int i=1;i<argc;i++) {
			switch (argv[i][1]) {
				case 'c':
					sscanf(argv[1+i++],"%d",&g_nCraftsman);
					break;
				case 'i':
					sscanf(argv[1+i++],"%d",&g_nInhabitant);
					break;
				case 'm' :
					sscanf(argv[1+i++],"%d",&g_nMaxThread);
					break;
				case 'r' :
					sscanf(argv[1+i++],"%d",&g_nResponseTime);
					break;
				case 't' :
					sscanf(argv[1+i++],"%d",&g_nThreadCreateTime);
					break;
				case 'h':
					throw 0;
				case 'v':
					OutVersion();
					return 0;
				default:
					printf("FATAL: Unknown switch \"%c\"\n",argv[i][1]);
					throw 0;
			}
		}
	} catch(...) {
		// 蔲
		OutUsage();
		return 0;
	}

	// 
	srand((unsigned int)time(0));

/*
	printf("Parameters : \n");
	printf("Crafts=%d, Inhabitant=%d, MaxThread=%d, ResponseTime=%d, ThreadTime=%d\n",
			g_nCraftsman,g_nInhabitant,g_nMaxThread,g_nResponseTime,g_nThreadCreateTime);
*/

	// datfBNg쐬
	system ("mkdir dat");

	// 
	CThreadManager  thman;
	CInhabitant*    ibs = new CInhabitant[g_nInhabitant];

	for (int i=0;i<g_nInhabitant;i++) {
		unsigned char  ip[4];
		char  id[9];

		CreateIP(ip);
		CreateID(8,id);

		// n߂craftsmanl͐El
		ibs[i].Set("",DEFAULTMAIL,ip,id,i<g_nCraftsman);
	}

	// C[v (Windowsł͒Eokbhitg邨 (OցO ))
	printf("Press any key to exit...\n");
	bool  bExit=false;

#ifndef WIN32
	timeval		tv;
	fd_set		rfds;
	tv.tv_sec = 1;
	tv.tv_usec = 0;
#endif

	do {
		for (int i=0;i<g_nInhabitant;i++) { ibs[i].Think(&thman); }
		sleep_wrap(50);

#ifdef WIN32
		bExit = kbhit()!=0;
#else
		FD_ZERO(&rfds);		// select̏
		FD_SET(0,&rfds);	// stdin̊Ď
		bExit = (bool)select(1, &rfds, NULL, NULL, &tv);
#endif
	} while(!bExit);

	delete[]  ibs;
	return 0;
}
