#include "vita_classes.h"

void CInhabitant::Set(const char* name,const char* mail,unsigned char IP[4],const char* ID,bool bCraftsman) {
	// 
	strcpy(m_sName,name);
	strcpy(m_sMail,mail);
	strcpy(m_sID,ID);
	memcpy(m_nIP,IP,sizeof(unsigned char)*4);
	m_bCraftsman = bCraftsman;

	m_nResTimeThreshold = (int)GaussRand((double)g_nResponseTime,5.0);
	if (m_nResTimeThreshold < 0) { m_nResTimeThreshold *= -1; }

	if (!bCraftsman) {
		m_nThreadTimeThreshold = 0;
	} else {
		m_nThreadTimeThreshold = (int)GaussRand((double)g_nThreadCreateTime,5.0);
		if (m_nThreadTimeThreshold < 0) { m_nThreadTimeThreshold *= -1; }
	}

	time(&m_nResTime);
	time(&m_nThreadTime);
}

const char* CInhabitant::ThinkTitle(time_t v) {
	switch((unsigned int)v%3) {
		case 0:	return "i OցOj ް";
		case 1: return "lKꂻł";
		case 2: return "iOցOGj̊ނ߂";
	}
	return "傗";
}

const char* CInhabitant::Think1Kakiko(time_t v) {
	switch((unsigned int)v%3) {
		case 0:	return "@@@@ @@^܁R<br>i@OցOj<br>@@@@@|@@@ / @ @@@ް<br>@ @@@ i@Rm<br>@@@@@ >m<br>@ O@@<br>";
		case 1: return "ĉ ><";
		case 2: return "iOցOGj̊VIPł͎g";
	}
	return "ˁ[悗";
}

const char*	CInhabitant::ThinkKakiko(time_t v) {
	switch((unsigned int)v%3) {
		case 0:	return "@@@@ @@^܁R<br>i@OցOj<br>@@@@@|@@@ / @ @@@ް<br>@ @@@ i@Rm<br>@@@@@ >m<br>@ O@@<br>";
		case 1: return "邠邗";
		case 2: return "ˁ[悗";
	}
	return "hosyu";
}

void CInhabitant::Think(CThreadManager* p) {
	time_t  v;
	time(&v);

	if (m_bCraftsman && (v - m_nThreadTime) >= m_nThreadTimeThreshold) {
		// thistȂCygwingcc{I
		p->Create(m_sName,m_sMail,this->ThinkTitle(v),Think1Kakiko(v),m_sID);
		time(&m_nThreadTime);
	}
	if ((v - m_nResTime) >= m_nResTimeThreshold) {
		if (p->Size()) {
			p->GetRandomThread()->WriteRes(m_sName,m_sMail,ThinkKakiko(v),m_sID);
			p->Check();
			time(&m_nResTime);
		}
	}
}

// ----------------------------------------------------------------------------

/*
void CSubjectManager::LockSubject(bool bWrite) {
	static const char subjectlock_read[] = "./subject.txt.rlock";
	static const char subjectlock_write[] = "./subject.txt.wlock";
	Lock(bWrite ? subjectlock_write:subjectlock_read);
}

void CSubjectManager::UnlockSubject(bool bWrite) {
	static const char subjectlock_read[] = "./subject.txt.rlock";
	static const char subjectlock_write[] = "./subject.txt.wlock";
	Unlock(bWrite ? subjectlock_write:subjectlock_read);
}
*/

bool CSubjectManager::SubjectCheck() {
	FILE* fp;

	// 蔲 (̎蔲͂킩)
	fp = fopen("subject.txt","r");
	if (fp==NULL) {
		fp = fopen("subject.txt","w");
		if (fp==NULL) { return false; }
		fprintf(fp,"\n\n");
		fclose(fp);
	} else { fclose(fp); }
	return true;
}


bool CSubjectManager::AddToSubject(const char* sDatName,const char* sThreadTitle) {
	LockSubject();
	if (!SubjectCheck()) { return false; }

	// 擪ɏ͔̂ɖʓ|
	// TODO: ƏȂƂ߂xȂC
	if (rename("subject.txt","old_subject.txt")) {
		printf("Warning : subject.txt rename error (reason=%d)\n",errno);
		UnlockSubject();
		return false;
	}
	FILE* fpw = fopen("subject.txt","w");
	if (fpw==NULL) { printf("Warning : subject.txt open error (OnAdd)\n"); return false; }
	fprintf(fpw,sDatName);
	fprintf(fpw,"<>");
	fprintf(fpw,sThreadTitle);
	fprintf(fpw," (1)\n");

	// old_subject.txt̓esubject.txtɈڍs
	char buf[512];
	size_t reads;
	FILE* fpr = fopen("old_subject.txt","r");
	if (fpr==NULL) { printf("Warning : old_subject.txt open error (OnWrite)\n"); goto _end; }
	while ((reads=fread(buf,sizeof(char),512,fpr))!=0) {
		fwrite(buf,sizeof(char),reads,fpw);
	}

_end:
	// old_subject͗pς
	fclose(fpr);
	fclose(fpw);
	// Rsƍ
	if (remove("old_subject.txt")) { printf("Warning : old_subject.txt delete error\n"); }

	UnlockSubject();
	return true;
}

// subject.txtɏ݂s (郌X+1)
// XĎAddToSubjectĂяoB
bool CSubjectManager::WriteToSubject(const char* sDatName) {
	LockSubject();
	if (!SubjectCheck()) { UnlockSubject(); printf("Subject check failed\n"); return false; }
	bool bRet = true;

	// rǋLɖʓ|
	// TODO: ƏȂƂ߂xȂC
	if (rename("subject.txt","old_subject.txt")) {
		// ((L֥`)
		sleep_wrap(1000);
		if (rename("subject.txt","old_subject.txt")) {
			printf("Warning : subject.txt rename error (reason=%d)\n",errno);
			UnlockSubject();
			return false;
		}
	}
	FILE* fpw = fopen("subject.txt","w");
	if (fpw==NULL) { printf("Warning : subject.txt open error (OnWrite)\n"); UnlockSubject(); return false; }

	// PsǂŁAdat̖Oz͕ς
	FILE* fpr = fopen("old_subject.txt","r");
	if (fpr==NULL) { printf("Warning : old_subject.txt open error (OnWrite)\n"); UnlockSubject(); return false; }
	char buf[512];
	bool found=false;
	// while (fgets(buf,512,fpr)!=NULL) {
	while (fgets(buf,512,fpr)!=NULL) {
		// 14 = **********.dat ̒
		if (!found && strncmp(buf,sDatName,14)==0) {
			char numstr[5];
			char* pf = strrchr(buf,'(');
			char* pt = strrchr(buf,')');
			if (pf!=NULL && pt!=NULL) {
				strncpy(numstr,pf+1,pt-pf-1);
				int res = atoi(numstr);

				fwrite(buf,sizeof(char),pf-buf+1,fpw);
				fprintf(fpw,"%d)\n",++res);
				found = true;
			}
		} else {
			fputs(buf,fpw);
		}
	}

	// [H
	if (!found) {
		printf("Warning : Requested thread not found (compressed?)\n");
		bRet = false;
	}

	// old_subject͗pς
	fclose(fpr);
	fclose(fpw);

	// Rsƍ
	if (remove("old_subject.txt")) { printf("Warning : old_subject.txt delete error\n"); }

	UnlockSubject();
	return bRet;
}

// ----------------------------------------------------------------------------

// datt@Cݒ
void CDatGenerator::GetNewDat(char* p) {
	char buf[MAX_STRING];
	time (&m_nDatTime);	// Xbh쐬擾
	do {
#ifdef WIN32
		sprintf(buf,"dat\%d.dat",m_nDatTime);
#else
		sprintf(buf,"dat/%d.dat",m_nDatTime);
#endif
		m_nDatTime++;
	}while (IsAlreadyCreate(buf));
	strcpy(p,buf);
}

// ɂdatt@C邩ׂ
// trueFɂ falseF܂Ȃ
bool CDatGenerator::IsAlreadyCreate (char *p) {
	FILE *fp;
	fp = fopen (p, "r");
	if(fp!=NULL) {
		fclose (fp);
		return true;
	}
	else
		return false;
}

// ----------------------------------------------------------------------------

CThread::CThread(const char* sDatPath,const char* sTitle,const char* sName,const char* sMail,const char* sID,const char* sKakiko)
: m_bKillMe(false), m_nRes(0) {
	// bNIɂJق悭ˁH
	strcpy(m_sPath,sDatPath);
	WriteRes(sName,sMail,sKakiko,sID,sTitle);
}

void CThread::Release() {
}

void CThread::LockDat(/*bool bWrite*/) {
/*
	static const char datlock_suffix_read[] = ".rlock";
	static const char datlock_suffix_write[] = ".wlock";

	char  buf[128];
	strcpy(buf,m_sPath);
	strcat(buf,bWrite ? datlock_suffix_write:datlock_suffix_read);
	Lock(buf);
*/
	char  buf[128];
	strcpy(buf,m_sPath);
	strcat(buf,".lock");
	Lock(buf);
}

void CThread::UnlockDat(/*bool bWrite*/) {
/*
	static const char datlock_suffix_read[] = ".rlock";
	static const char datlock_suffix_write[] = ".wlock";

	char  buf[128];
	strcpy(buf,m_sPath);
	strcat(buf,bWrite ? datlock_suffix_write:datlock_suffix_read);
	Unlock(buf);
*/
	char  buf[128];
	strcpy(buf,m_sPath);
	strcat(buf,".lock");
	Unlock(buf);
}

int CThread::WriteRes(const char* sName,const char* sMail,const char* sKakiko,const char* sID,const char* sThreadTitle) {
	// ƌ킯Ŗ󂯂邨 OցO;
	LockDat();

	FILE* fp = fopen(m_sPath,"a");
	if (fp==NULL) {
		printf("%s open failed (moved?)",m_sPath);
		return -1;
	}

	// O
	if (sName[0] != '\0') { fprintf(fp,"%s",sName); } else { fprintf(fp,"%s",DEFAULTNAME); }
	fprintf(fp,"<>");

	// [
	fprintf(fp,"%s",sMail);
	fprintf(fp,"<>");
	
	// t
	time_t timeValue;
	struct tm *timeObject;
	time (&timeValue);
	timeObject = localtime (&timeValue);
	fprintf (fp, "%d/%d/%d", timeObject->tm_year+1900, timeObject->tm_mon+1, timeObject->tm_mday);
	switch (timeObject->tm_wday) {
		case 0: fprintf (fp, "() "); break;
		case 1: fprintf (fp, "() "); break;
		case 2: fprintf (fp, "() "); break;
		case 3: fprintf (fp, "() "); break;
		case 4: fprintf (fp, "() "); break;
		case 5: fprintf (fp, "() "); break;
		case 6: fprintf (fp, "(y) "); break;
		default: fprintf (fp, "(?) "); break;
	}
	// 
	if (timeObject->tm_hour > 10)	fprintf(fp,"%d:",timeObject->tm_hour);
	else							fprintf(fp,"0%d:",timeObject->tm_hour);
	if (timeObject->tm_min > 10)	fprintf(fp,"%d:",timeObject->tm_min);
	else							fprintf(fp,"0%d:",timeObject->tm_min);
	if (timeObject->tm_sec > 10)	fprintf(fp,"%d",timeObject->tm_sec);
	else							fprintf(fp,"0%d",timeObject->tm_sec);
	// ID
	fprintf (fp, "ID:%s",sID);
	fprintf (fp, "<>");
	
	// {
	fprintf(fp,"%s",sKakiko);
	fprintf(fp,"<>");
	// PJLRAŌɃ^Cgt
	if (sThreadTitle!=NULL) { fprintf (fp,sThreadTitle); }
	fprintf(fp,"\n");

	// Ô
	// fflush(fp);
	fclose(fp);

	// XXV....
	m_nRes++;
	if (m_nRes>=g_nMaxKakiko) {
		printf("INFO: %s reached %d\n",m_sPath,g_nMaxKakiko);
		m_bKillMe = true;
	}

	// subject.txtXV
	if (sThreadTitle!=NULL) { g_SubjectManager.AddToSubject(m_sPath,sThreadTitle); }
	else { if (!g_SubjectManager.WriteToSubject(m_sPath)) {
		printf("INFO: %s write error\n",m_sPath);
		m_bKillMe = true; }
	}

	UnlockDat();
	return 0;
}

// ----------------------------------------------------------------------------

CThreadManager::~CThreadManager() {
	std::vector<CThread *>::iterator  it = m_vThreads.begin();
	while (it!=m_vThreads.end()) { delete (*it++); }
}

void CThreadManager::Create(const char* sName,const char* sMail,const char* sTitle,const char* sKakiko,const char *sID) {
	char  buf[16];
	m_unGen.GetNewDat(buf);

	printf("INFO: New thread (->%d) %s:%s\n",m_vThreads.size()+1,buf,sTitle);
	m_vThreads.push_back(new CThread(buf,sTitle,sName,sMail,sKakiko,sID));
}

void CThreadManager::Check() {
	// JLRƂɌĂł邩ÃR[h͌AAA
	std::vector<CThread *>::iterator  it = m_vThreads.begin();
	while (it!=m_vThreads.end()) {
		if ((*it)->IsKill()) {
			printf("INFO: %s Killed (->%d).\n",(*it)->GetName(),m_vThreads.size()-1);

			delete (*it);
			it = m_vThreads.erase(it);
		} else { it++; }
	}
}
