#ifndef __VITA_CLASSES__
#define __VITA_CLASSES__

#include "vita_option.h"
#include "vita_funcs.h"

class CInhabitant;
class CThread;
class CThreadManager;
class CSubjectManager;

class CInhabitant {
protected:
	// int		m_nNum;					// Zl̔ԍ
	char	m_sName[MAX_STRING];	// Zl̖O
	char	m_sMail[MAX_STRING];	// Zl̃[
	char	m_sID[9];				// ZlID
	unsigned char m_nIP[4];			// ZlIPAhX

	int		m_nResTimeThreshold;	// XԂ臒l
	time_t	m_nResTime;				// O񃌃X
	bool	m_bCraftsman;			// XĐElǂ
	int		m_nThreadTimeThreshold;	// XĎԂ臒l
	time_t	m_nThreadTime;			// OXĂ

	// LӖVы@\
	const char* ThinkTitle(time_t v);
	const char*	ThinkKakiko(time_t v);
	const char*	Think1Kakiko(time_t v);

public:
	CInhabitant() {}
	CInhabitant(const char* name,const char* mail,unsigned char IP[4],const char* ID,bool bCraftsman)
	{ Set(name,mail,IP,ID,bCraftsman); }

	// lx
	void	Set(const char* name,const char* mail,unsigned char IP[4],const char* ID,bool bCraftsman);
	// C[vĂ΂BԂɂăJLRXĂs
	void	Think(CThreadManager* p);
};

class CSubjectManager {
// subject.txtǋL㏑ (O[oɂłĂ)
protected:
public:
	void	LockSubject()		{ Lock("subject.txt.lock"); }
	void	UnlockSubject()		{ Unlock("subject.txt.lock"); }
	bool	SubjectCheck();

public:
	CSubjectManager() { FILE *fp=fopen("subject.txt","w"); fprintf(fp,"\n\n"); fclose(fp);}
	bool	AddToSubject(const char* sDatName,const char* sThreadTitle);
	bool	WriteToSubject(const char* sDatName);
};

class CDatGenerator {
// XXXXXXXXXX.datƌt@C𐶐B
// XXXXXXXX10P^UNIXWԁBXbh쐬ԂƓB
protected:
	time_t	m_nDatTime;

public:
	CDatGenerator() {}

	void GetNewDat(char* p);
	bool IsAlreadyCreate (char *p);
};

class CThread {
protected:
	char	m_sTitle[MAX_STRING];		// X^C
	char	m_sPath[MAX_STRING];		// datt@C̃pX
	FILE*	m_fp;						// datt@Cւ̃t@C|C^
	int		m_nRes;						// X̃X
	bool	m_bKillMe;					// ꂪtrueɂȂCThreadManagerO (=ߋ҂)

protected:
	// datbN
	void	LockDat();
	void	UnlockDat();

public:
	CThread(const char* sDatPath,const char* sTitle,const char* sName,const char* sMail,const char* sKakiko,const char* sID);
	virtual ~CThread() { Release(); }

	// t@C
	void	Release();

	//  (0=OK)
	int		WriteRes(const char* sName,const char* sMail,const char* sKakiko,const char* sID,const char* sThreadTitle=NULL);
	// Oė~
	bool	IsKill() { return m_bKillMe; }
	// O
	const char* GetName() { return m_sPath; }
};

class CThreadManager {
protected:
	std::vector<CThread *>  m_vThreads;
	CDatGenerator			m_unGen;

public:
	virtual ~CThreadManager();

	// XĂs
	void	Create(const char* sName,const char* sMail,const char* sTitle,const char* sKakiko,const char* sID);
	// KȃXԂ
	CThread* GetRandomThread()	{ return m_vThreads.size()==0 ? NULL:m_vThreads[rand()%m_vThreads.size()]; }
	// X
	size_t	Size() { return m_vThreads.size(); }

	// Kill (JLRƂɌĂ)
	void	Check();
};

#endif
