#include "vita_funcs.h"

void Lock(const char* lockname) {
	FILE* fp;

	fp = fopen(lockname,"r");
	while(fp!=NULL) {
		char  buf[5];
		fread(buf,sizeof(char),4,fp);
		fclose(fp);

		if (memcmp(buf,"vita",4)==0) { return; }

		printf("INFO: %s locking...\n",lockname);
		sleep_wrap(100);	// 0.1b҂

		fp = fopen(lockname,"r");
	};
	fp = fopen(lockname,"w");
	fprintf(fp,"vita");
	fclose(fp);
}

void Unlock(const char* lockname) {
	remove(lockname);
}

void CreateIP(unsigned char ip[4]) {
	for (int i=0;i<4;i++) { ip[i] = rand()%256; }
}

void CreateID(int figure,char* to) {
	// A:26 N:10

	for (int i=0;i<figure;i++) {
		char n = rand()%36;
		if (n<10) { to[i] = '0'+n; } else {
			to[i] = 'A'+n-10;
		}
	}
	to[figure] = '\0';
}

double GaussRand (double ave , double s) {
	double random;
	double ans;

	random = (double) rand ( ) / RAND_MAX;
	while (random == 0.0)
		random = (double) rand ( ) / RAND_MAX;
	ans = sqrt (-2 * log (random)) * cos (2 * PAI * random);
	return (ans * s + ave);
}

void sleep_wrap(unsigned long w) {
#ifdef WIN32
	Sleep(w);
#else
	usleep(w*1000);
#endif
}
